﻿-- Show all characters on account

-- Stats to show: name, race, class, level, zone, guild, professions, gold, Xp, rested bonus, bag slots, bank slots, hearthstone

-- Bottom pane: show all relevant stats for selected character 

TOONSTAB={};

TOONSVAR={};

ToonsServer={};

ToonsPage={};

--[[
MoneyTypeInfo["ASSETS"] = {

	UpdateFunc = function()

		return this.staticMoney;

	end,

	collapse = 1,

	showSmallerCoins = "Backpack",

};
]]

tinsert(FRIENDSFRAME_SUBFRAMES, "ToonsFrame");

function ToonsFrame_OnLoad()

	this:RegisterEvent("VARIABLES_LOADED");

	this:RegisterEvent("PLAYER_ENTERING_WORLD");

	this:RegisterEvent("PLAYER_LEAVING_WORLD");

	this:RegisterEvent("PLAYER_LOGOUT");

	this:RegisterEvent("ZONE_CHANGED_NEW_AREA");

	this:RegisterEvent("TIME_PLAYED_MSG");

	this:RegisterEvent("PLAYER_MONEY");
	
	this:RegisterEvent("TRADE_SKILL_SHOW");
	
	this:RegisterEvent("CRAFT_SHOW");

    FriendsFrameToonsTab, ToonsTabFrame = FriendsFrameTab_CreateTab("ToonsFrame", TOONS);

	FriendsFrameToonsTab_Initialize( getglobal(ToonsTabFrame) );

	ChatFrame_DisplayTimePlayed = Toons_ChatFrame_DisplayTimePlayed;
	
	SLASH_TOONS1 = "/toons";
	
	SlashCmdList["TOONS"] = Toons_OnSlashCmd;


end

function ToonsFrame_OnShow()

	Toons_Get_TradeskillInfo();

    ToonsTab_UpdateAll();

	SetPortraitTexture(ToonsFramePortrait, "player");

end

function ToonsFrame_OnHide()

	SetPortraitTexture(ToonsFramePortrait, "player");

end

function ToonsFrame_OnEvent()

	if (event=="VARIABLES_LOADED") then 

        local server = GetRealmName();

		local player = UnitName("player");

		if (not TOONSTAB) or (not TOONSTAB[server]) or (not TOONSTAB[server][player]) then

   			Toons_CreateToon();

		end

  		Toons_All_Data_Check();
		
		Toons_ToonsVar_Check();

		ToonsFrame.sortDirection = TOONSVAR.sortDirection;
		
		ToonsFrame.sortKey = TOONSVAR.sortKey;

		ToonsFrame.page = TOONSVAR.page;

		ToonsFrame.server = server;

		ToonsPage = ToonsPage_Sort();

		ToonsServer = ToonsServer_Sort();

		this:RegisterEvent("BAG_UPDATE");

		this:RegisterEvent("PLAYERBANKSLOTS_CHANGED");

		this:RegisterEvent("BANKFRAME_OPENED");

		this:RegisterEvent("GUILD_ROSTER_UPDATE");
		
		this:RegisterEvent("PLAYER_GUILD_UPDATE");
		
		this:RegisterEvent("UNIT_QUEST_LOG_CHANGED");
		
		this:RegisterEvent("QUEST_FINISHED");
		
		this:RegisterEvent("CHAT_MSG_SKILL");

		this:RegisterEvent("PLAYER_LEVEL_UP");

		this:RegisterEvent("PLAYER_XP_UPDATE");

 		this:RegisterEvent("PLAYER_UPDATE_RESTING");

	    this:RegisterEvent("UPDATE_EXHAUSTION");	

		this:RegisterEvent("TRADE_SKILL_UPDATE");

		this:RegisterEvent("TRADE_SKILL_CLOSE");

		this:RegisterEvent("UNIT_PORTRAIT_UPDATE");
		
		this:RegisterEvent("HONOR_CURRENCY_UPDATE");
		
		this:RegisterEvent("ACHIEVEMENT_EARNED");

		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000 Toons "..T_VERSION.." successfully loaded |r");
		
		if IsAddOnLoaded("myAddons") then
			Toonsdetails = {
			name = GetAddOnMetadata("Toons", "Title"), 
			version = GetAddOnMetadata("Toons", "Version"), 
			releaseDate = GetAddOnMetadata("Toons", "X-Date"), 
			author = GetAddOnMetadata("Toons", "Author"), 
			website = GetAddOnMetadata("Toons", "X-Website"),
			category = MYADDONS_CATEGORY_OTHERS,
			};
		myAddOnsFrame_Register(Toonsdetails);
		end
		
		Toons_Check_LDB();
		
		Toons_Get_LastPlayed();

	elseif (event=="PLAYER_ENTERING_WORLD") then

        oldGuildErrorMsg = ERR_GUILD_PLAYER_NOT_IN_GUILD;

		ERR_GUILD_PLAYER_NOT_IN_GUILD = "";

		if TOONSVAR.ToonsDataVersion ~=T_DATA_VERSION then
				ToonsVerError(TOONSVAR.ToonsVersion);
		end
		
		ToonsTab_UpdateAll();
		
		ToonsFrame:Show();
		
		ToonsFrame:Hide();
		
	elseif (event=="PLAYER_LEAVING_WORLD") then
		
		this:UnregisterEvent("BAG_UPDATE");

		this:UnregisterEvent("PLAYERBANKSLOTS_CHANGED");

		this:UnregisterEvent("BANKFRAME_OPENED");

		this:UnregisterEvent("GUILD_ROSTER_UPDATE");

	elseif (event=="PLAYER_LOGOUT") then

		Toons_Get_LastPlayed();

		TOONSVAR.ToonsVersion=T_VERSION;
		
		TOONSVAR.ToonsDataVersion=T_DATA_VERSION;
		
		TOONSVAR.sortDirection = ToonsFrame.sortDirection;
		
		TOONSVAR.sortKey = ToonsFrame.sortKey;

		TOONSVAR.page = ToonsFrame.page;

		TOONSVAR.memused, TOONSVAR.garbage = gcinfo();

	elseif (event=="ZONE_CHANGED_NEW_AREA") then

		ToonsTab_Update( "zone", GetZoneText(), "char" );

		ToonsFrame_Update();

	elseif (event=="BAG_UPDATE") then

		if ( arg1 <= NUM_BAG_SLOTS ) then

			Toons_Get_BagsSize();

		elseif ( BankFrame:IsVisible() and arg1 > NUM_BAG_SLOTS and arg1 < NUM_BAG_SLOTS+NUM_BANKBAGSLOTS ) then

			Toons_Get_BankSize();

		end

		ToonsFrame_Update();

	elseif (event=="PLAYER_MONEY") then

		local money = GetMoney ();

		ToonsTab_Update( "gold", money, "assets" );

		ToonsFrame_Update();

	elseif ((event=="PLAYERBANKSLOTS_CHANGED") 

		or (event=="BANKFRAME_OPENED")) then

		Toons_Get_BankSize();

		ToonsFrame_Update();

	elseif (event=="TRADE_SKILL_UPDATE")

		or (event=="TRADE_SKILL_CLOSE") 
		
		or (event=="CHAT_MSG_SKILL") then

		Toons_Get_TradeskillInfo();

		ToonsFrame_Update();

	elseif (event=="TRADE_SKILL_SHOW")
		or (event=="CRAFT_SHOW")then
	
		Toons_Get_TradeskillLink();
		
	elseif (event=="PLAYER_LEVEL_UP") then

		ToonsTab_Update( "level", arg1, "char");

		ToonsFrame_Update();

	elseif ((event=="PLAYER_XP_UPDATE")

        or (event=="PLAYER_UPDATE_RESTING")

        or (event=="UPDATE_EXHAUSTION")) then

		Toons_Get_Xp();

        ToonsFrame_Update();

    elseif (event=="GUILD_ROSTER_UPDATE") or
			(event=="PLAYER_GUILD_UPDATE") then

		Toons_Get_Guild();

		ToonsFrame_Update();

	elseif (event=="TIME_PLAYED_MSG") then

		ToonsTab_Update( "timeplayed", arg1, "time");

		ToonsTab_Update( "timeatlevel", arg2, "time" );
		
		Toons_Get_Offset();
		
		Toons_Get_TradeskillInfo();
		
		ToonsFrame_Update();

	elseif ( event == "UNIT_PORTRAIT_UPDATE" ) then

		if ( arg1 == "player" ) then

			SetPortraitTexture(ToonsFramePortrait, arg1);

		end

	elseif ( event == "HONOR_CURRENCY_UPDATE" ) then
	
	    Toons_Get_Honor();
		Toons_Get_Marks();

	elseif ( event == "UNIT_QUEST_LOG_CHANGED") 
			or ( event == "QUEST_FINISHED") then

		Toons_Get_Daily();
		
		ToonsFrame_Update();

	elseif (event=="ACHIEVEMENT_EARNED") then
	
		Toons_Get_Achieve();
	
	end

end

function ToonsTab_Update( key, value , subtab)

	local server = GetRealmName();

	local player = UnitName("player");


	if subtab then
	
		if ( TOONSTAB and TOONSTAB[server] and TOONSTAB[server][player]) then
			
			if not TOONSTAB[server][player][subtab] then
				TOONSTAB[server][player][subtab] = {};
			end
			TOONSTAB[server][player][subtab][key] = value;
	
			return key, value, subtab;
		end
	else
		if ( TOONSTAB and TOONSTAB[server] and TOONSTAB[server][player] ) then

			TOONSTAB[server][player][key] = value;

			return key, value;

		end
	
	end

end

function ToonsTab_UpdateAll()

	local server = GetRealmName();

	local player = UnitName("player");

	local gold = GetMoney();
	
	ToonsTab_Update( "name", player );

	Toons_Get_Char();
	
	Toons_Get_Xp()
	
	ToonsTab_Update( "gold", gold , "assets" );
	
	Toons_Get_Guild();

	Toons_Get_BagsSize();
	
	Toons_Get_Honor();
	
	Toons_Get_Marks();
	
	Toons_Get_Daily();

    Toons_RequestTimePlayed();
	
	Toons_Get_Achieve();
	
	Toons_Get_TradeskillInfo();
	
	ToonsFrame_Update();

end

function ToonsServer_GetID( server )

	for i=1, #(ToonsServer) do

		if ( ToonsServer[i]==server ) then

			return i;

		end

	end

end

function ToonsPage_GetID( page )

	for i=1, #(ToonsPage) do

		if ( ToonsPage[i]==page ) then

			return i;

		end

	end

end

function Toons_RequestTimePlayed()

	Toons_RequestTime = 1;

	RequestTimePlayed();

end

local old_ChatFrame_DisplayTimePlayed = ChatFrame_DisplayTimePlayed;

function Toons_ChatFrame_DisplayTimePlayed(totalTime, levelTime, ...)

	if ( Toons_RequestTime == 1) then

		Toons_RequestTime = 0;

		return;

	else

		old_ChatFrame_DisplayTimePlayed(totalTime, levelTime, ...);

	end

end


function Toons_CreateToon(server, player)

    -- Create saved variables that don't already exist
	local server = GetRealmName();

	local player = UnitName("player");

	if ( not TOONSVAR ) then

		TOONSVAR = {};
		
	end
	
	if ( not TOONSVAR.ToonsVersion ) then
	
		TOONSVAR.ToonsVersion = T_VERSION;
		
	end
	
	if ( not TOONSVAR.ToonsDataVersion ) then
	
		TOONSVAR.ToonsDataVersion = 0;
	
	end
	
	if ( not TOONSVAR.sortDirection ) then

		TOONSVAR.sortDirection = "down";

	end
	
	if ( not TOONSVAR.sortKey ) then

		TOONSVAR.sortKey = "name";

	end

	if ( not TOONSVAR.page ) then

		TOONSVAR.page = "STATSFRAME";

	end

	if ( not TOONSVAR.memused ) then

		TOONSVAR.memused = "";

	end

	if ( not TOONSVAR.garbage ) then

		TOONSVAR.garbage = "";

	end
	
	if ( not TOONSVAR.offset ) then

		TOONSVAR.offset = {};
		TOONSVAR.offset[server] = 0;

	end

	if ( not TOONSTAB) then

		TOONSTAB = {};

	end

	if ( not TOONSTAB[server] ) then

        TOONSTAB[server] = {} ;

	end

	if ( not TOONSTAB[server][player] ) then

        TOONSTAB[server][player] = {} ;       

	end	

	for i,v in pairs(TOONSDATA) do

		if (not TOONSTAB[server][player][i]) then

			TOONSTAB[server][player][i]= v;

		end

	end	

	ToonsTab_Update( "name", player );

	Toons_Get_Char();

	Toons_Get_Xp();
	
	Toons_Get_Guild();
	
	Toons_Get_BagsSize();
	
	Toons_Get_Honor();
	
	Toons_Get_Marks();
	
	Toons_Get_Daily();
	
	Toons_Get_LastPlayed();

    Toons_Get_TradeskillInfo();
	
	ToonsFrame_Update();

end

function Toons_All_Data_Check()

	local server,player, data;

	if ( not TOONSTAB) then

		TOONSTAB = {};

	else

	for server,data in pairs(TOONSTAB) do

		for player,data in pairs(TOONSTAB[server]) do

			for i,v in pairs(TOONSDATA) do

				if (not TOONSTAB[server][player][i]) then

					TOONSTAB[server][player][i]= v;

				elseif (TOONSTAB[server][player][i]=="") then

					TOONSTAB[server][player][i]= v;

				end

			end

		end	

	end

	end

end

function Toons_ToonsVar_Check()

	local server = GetRealmName();

	local player = UnitName("player");

	if ( not TOONSVAR ) then

		TOONSVAR = {};
		
	end
	
	if ( not TOONSVAR.ToonsVersion ) then
	
		TOONSVAR.ToonsVersion = T_VERSION;
		
	end
	
	if ( not TOONSVAR.ToonsDataVersion ) then
	
		TOONSVAR.ToonsDataVersion = 0;
	
	end 
	
	if ( not TOONSVAR.sortDirection ) then

		TOONSVAR.sortDirection = "down";

	end
	
	if ( not TOONSVAR.sortKey ) then

		TOONSVAR.sortKey = "name";

	end

	if ( not TOONSVAR.page ) then

		TOONSVAR.page = "STATSFRAME";

	end

	if ( not TOONSVAR.memused ) then

		TOONSVAR.memused = "";

	end

	if ( not TOONSVAR.garbage ) then

		TOONSVAR.garbage = "";

	end
	
	if ( not TOONSVAR.offset ) then

		TOONSVAR.offset = {};
		TOONSVAR.offset[server] = 0;

	end


end

function Toons_Get_Char()

	local server = GetRealmName();

	local player = UnitName("player");

	local race, raceEn = UnitRace("player");

	local class, classEn = UnitClass("player");

	local level = UnitLevel("player");

	local zone = GetZoneText();

	local sex = UnitSex("player");

	local factionEn, faction = UnitFactionGroup("player");

	local home = GetBindLocation();

	ToonsTab_Update( "raceEn", raceEn, "char" );
	
	ToonsTab_Update( "race", race, "char" );

	ToonsTab_Update( "classEn", classEn, "char" );
	
	ToonsTab_Update( "class", class, "char" );

	ToonsTab_Update( "level", level, "char" );

	ToonsTab_Update( "zone", zone, "char" );

	ToonsTab_Update( "sex", sex, "char" );
	
	ToonsTab_Update( "factionEn", factionEn, "char" );
	
	ToonsTab_Update( "faction", faction, "char" );
	
	ToonsTab_Update( "homeinn", home, "char" );
	
end

function Toons_Get_Xp()

	local server = GetRealmName();

	local player = UnitName("player");

	local xprested= GetXPExhaustion() or 0;
	
	local xp = UnitXP("player");
	
	local xpmax = UnitXPMax("player");
	
	local xppct = xp/xpmax;
	
	local restedpct = xprested/(xpmax * 1.5);
	
	ToonsTab_Update( "xp", xp, "txp" );

	ToonsTab_Update( "xpmax", xpmax, "txp"  );

	ToonsTab_Update( "rested", xprested, "txp"  );
	
	ToonsTab_Update( "xppct", xppct, "txp"  );
	
	ToonsTab_Update( "restedpct", restedpct, "txp"  );

end

function Toons_Get_Guild()

		local server = GetRealmName();

		local player = UnitName("player");
		
		if IsInGuild() then
		
			local guild, rank, index = GetGuildInfo("player");
		
			local gmembers = GetNumGuildMembers(true);

			ToonsTab_Update( "guild", guild, "guild" );

			ToonsTab_Update( "guildindex", index, "guild" );

			ToonsTab_Update( "guildrank", rank, "guild" );
		
			ToonsTab_Update( "gmembers", gmembers, "guild" );
			
		elseif not IsInGuild() then

			ToonsTab_Update( "guild", "", "guild" );

			ToonsTab_Update( "guildindex", 0, "guild" );

			ToonsTab_Update( "guildrank", "", "guild" );
		
			ToonsTab_Update( "gmembers", 0, "guild" );
			
		end
				
end

function Toons_Get_Honor()

	local hp = GetHonorCurrency();

	local ap = GetArenaCurrency();

	local lk = GetPVPLifetimeStats();

	ToonsTab_Update( "honorpoints", hp, "honor");

	ToonsTab_Update( "arenapoints", ap, "honor" );

	ToonsTab_Update( "lifekill", lk, "honor" );

end

function Toons_Get_Marks()

	local ab = GetItemCount(20559, 1);

	local av = GetItemCount(20560, 1);

	local ws = GetItemCount(20558, 1);

	local es = GetItemCount(29024, 1);
	
	local sa = GetItemCount(42425, 1);
	
	local wg = GetItemCount(43589, 1);

	local total = ab + av + ws + es + sa + wg;
	
	ToonsTab_Update( "abmarks", ab, "marks" );

	ToonsTab_Update( "avmarks", av, "marks" );

	ToonsTab_Update( "wsmarks", ws, "marks" );

	ToonsTab_Update( "esmarks", es, "marks" );

	ToonsTab_Update( "samarks", sa, "marks" );
	
	ToonsTab_Update( "wgmarks", wg, "marks" );
	
	ToonsTab_Update( "total", total, "marks" );

end

function Toons_Get_Daily()

	local dm = GetMaxDailyQuests();

	local dc = GetDailyQuestsCompleted();

	local dl = dm - dc;

	local dreset = GetQuestResetTime();
	
	ToonsTab_Update( "daily", dl, "dailies" );

	ToonsTab_Update( "dailymax", dm, "dailies" );
	
	ToonsTab_Update( "dailyreset", dreset, "dailies" );
	
	ToonsFrame_Update();

end

function Toons_Get_LastPlayed()

--local hour, min, sec, wday, day, month, year, yday, isdst = date("*t");
	local lpdate = date("*t");

	local ldate = date();
	
	ToonsTab_Update( "lpdate", lpdate );
	
	ToonsTab_Update( "ldate", ldate, "time" );
	
end

function Toons_Get_BagsSize()

	local size, max = 0, 0;

	for bag=0,4 do

		max = max+GetContainerNumSlots(bag);

		for slot=1, GetContainerNumSlots(bag) do

			local texture, itemCount = GetContainerItemInfo(bag, slot);

			if ( itemCount ) then

				size = size + 1;

			end

		end

	end

	ToonsTab_Update( "bagssize", size, "assets" );

	ToonsTab_Update( "bagsmax", max, "assets" );

end

function Toons_Get_BankSize()

	local size, max = 0, 28;

	for slotId=40,63 do -- bank slots as inventory ids

		if ( GetInventoryItemLink("player", slotId) ) then

			size = size + 1;

		end

	end

	for bag=NUM_BAG_SLOTS+1, NUM_BAG_SLOTS+GetNumBankSlots() do

		max = max+GetContainerNumSlots(bag);

		for slot=1, GetContainerNumSlots(bag) do

			if ( GetContainerItemLink(bag, slot) ) then

				size = size + 1;

			end

		end

	end

	ToonsTab_Update( "banksize", size, "assets" );

	ToonsTab_Update( "bankmax", max, "assets" );

end

function Toons_Get_TradeskillInfo()

	local profIndex=0;

    for j=5,7 do

		if ( GetSkillLineInfo(j)==TRADE_SKILLS ) then

			profIndex = j;

			break;

		end

	end

	local server, player = GetRealmName(), UnitName("player");

    local skill, header, _, curr, _, _, max = GetSkillLineInfo(1+profIndex);

	local newskill = SKILL_TYPE[skill] and skill;

	if ( newskill ) then

        ToonsTab_Update( "tradeskill1", skill, "profs" );

        ToonsTab_Update( "tradeskill1rank", curr, "profs" );

        ToonsTab_Update( "tradeskill1max", max, "profs" );
		
    end

    local skill, header, _, curr, _, _, max = GetSkillLineInfo(2+profIndex);

    local newskill = SKILL_TYPE[skill] and skill;

	if ( newskill ) then

        ToonsTab_Update( "tradeskill2", skill, "profs" );

        ToonsTab_Update( "tradeskill2rank", curr, "profs" );

        ToonsTab_Update( "tradeskill2max", max, "profs" );
		
    end

	  for s=1,15 do

        local skill, header, _, curr, _, _, max = GetSkillLineInfo(s);
		
        if ( skill == T_COOKING ) then

            local newskill = SKILL_TYPE[skill] and skill;

            if ( newskill ) then

                ToonsTab_Update( "tradeskill3", skill, "profs" );

                ToonsTab_Update( "tradeskill3rank", curr, "profs" );

                ToonsTab_Update( "tradeskill3max", max, "profs" );
				
            end

        elseif ( skill == T_FIRSTAID ) then

            local newskill = SKILL_TYPE[skill] and skill;

            if ( newskill ) then

                ToonsTab_Update( "tradeskill4", skill, "profs" );

                ToonsTab_Update( "tradeskill4rank", curr, "profs" );

                ToonsTab_Update( "tradeskill4max", max, "profs" );
				
            end

        elseif ( skill == T_FISHING ) then

			local newskill = SKILL_TYPE[skill] and skill;

            if ( newskill ) then

                ToonsTab_Update( "tradeskill5", skill, "profs" );

                ToonsTab_Update( "tradeskill5rank", curr, "profs" );

                ToonsTab_Update( "tradeskill5max", max, "profs" );

            end

        elseif ( skill == T_LOCKPICKING ) then

			local newskill = SKILL_TYPE[skill] and skill;

            if ( newskill ) then

                ToonsTab_Update( "tradeskill6", skill, "profs" );

                ToonsTab_Update( "tradeskill6rank", curr, "profs" );

                ToonsTab_Update( "tradeskill6max", max, "profs" );

            end

		end 

	end

end

function Toons_Get_Achieve()

	local server = GetRealmName();

	local player = UnitName("player");

	local atotal, acompleted = GetNumCompletedAchievements("player");
	
	local apoints = GetTotalAchievementPoints("player");
		
	ToonsTab_Update( "atotal", atotal, "achieve");
	
	ToonsTab_Update( "acompleted", acompleted, "achieve" );
	
	ToonsTab_Update( "apoints", apoints, "achieve" );
		
end

function Toons_Get_Offset()
	
		local server = GetRealmName();
		local ctime = date("*t");
		local Shour, Sminutes = GetGameTime();
		local offset = ctime.hour - Shour;

		TOONSVAR.offset[server] = offset;

end
	

function Toons_Get_TradeskillLink()

	local linked, who = IsTradeSkillLinked();
	local server = GetRealmName();
	local player = UnitName("player");
	local profs = "profs";
	if linked then return --check opened window to make sure its not linked
	else
		local tslink = GetTradeSkillListLink();
		if tslink ~= nil then
			for n = 1,5 do
				local tskill = "tradeskill"..n;
				if TOONSTAB[server][player][tskill] ~= "" then
					if string.find(tslink, TOONSTAB[server][player].profs[tskill] ) then --see if the tradeskill matches
						ToonsTab_Update( tskill, tslink, "tslink" ); -- save it all if it does
					elseif TOONSTAB[server][player].profs[tskill] == "Blacksmithing" then
							if string.find(tslink, "smith") then
								ToonsTab_Update( tskill, tslink, "tslink" );
							end
					elseif TOONSTAB[server][player].profs[tskill] == "Engineering" then
							if string.find(tslink, "Engine" ) then
								ToonsTab_Update( tskill, tslink, "tslink" );
							end
					elseif TOONSTAB[server][player].profs[tskill] == "Alchemy" then
							if string.find(tslink, "Master") then
								ToonsTab_Update( tskill, tslink, "tslink" );
							end
					end					
				end
			end
		end
	end
end

function ToonsVerError(Version)

StaticPopupDialogs["Toons_Ver_Err"] = {
  text = "Toons saved data not compatible with this version|n Toons may encounter errors if data is not reset. |n press Accept to clear all old data" ,
  button1 = "Accept",
  button2 = "Cancel",
  OnAccept = function()
      Toons_Data_Reset();
  end,
    OnCancel = function()
      Toons_cmdline_warning();
  end,
  timeout = 0,
  whileDead = 1,
  hideOnEscape = 1
};
	if not (TOONSVAR.ToonsDataVersion) or (TOONSVAR.ToonsDataVersion < T_DATA_VERSION) then
		
		StaticPopup_Show ("Toons_Ver_Err");
		
	end
end

function Toons_Data_Reset()
	TOONSTAB={};

	TOONSVAR={};

	ToonsServer={};

	ToonsPage={};

	Toons_CreateToon();
	
	ToonsFrame.sortDirection = TOONSVAR.sortDirection;

	ToonsFrame.page = TOONSVAR.page;

	ToonsFrame.server = GetRealmName();
	
	TOONSVAR.ToonsDataVersion = T_DATA_VERSION;

	ToonsPage = ToonsPage_Sort();

	ToonsServer = ToonsServer_Sort();
	
	if FriendsFrame:IsVisible() then
		FriendsFrame:Hide();
	end
	
	ToonsTab_UpdateAll()
	
end

function Toons_OnSlashCmd(msg, editbox)
	if msg == "reset" then
		StaticPopupDialogs["Toons_Reset"] = {	
		text = "Are you sure you want to reset? |n press Accept to clear all old data" ,
		button1 = "Accept",
		button2 = "Cancel",
		OnAccept = function()
			Toons_Data_Reset();
			end,
		timeout = 15,
		whileDead = 0,
		hideOnEscape = 1
};
		StaticPopup_Show ("Toons_Reset");
	elseif msg == "" then 	
		ToggleFriendsFrame( FriendsFrameToonsTab:GetID() );
	else print (" '/toons' to open/close toons");
		print (" '/toons reset' to reset all toons data"); 
	end
end

function Toons_cmdline_warning()


		StaticPopupDialogs["Toons_Warning"] = {	
		text = "You may delete data manually by erasing the WTF\\Account\\###\\SavedVariables\\toons.lua file |N  Or you may use '/toons reset' in game" ,
		button1 = "Accept",
		button2 = "Cancel",
		OnAccept = function()
			end,
		timeout = 30,
		whileDead = 0,
		hideOnEscape = 1
		};	


StaticPopup_Show ("Toons_Warning");
end
	