﻿function FriendsFrameTab_OnLoad()

	local parent = FriendsFrame; 

	local numTabs = parent.numTabs+1;

	PanelTemplates_SetNumTabs(parent, numTabs);

	PanelTemplates_EnableTab(parent, numTabs);

end



function FriendsFrameTab_CreateTab( subframe, subtext )

	local n=FriendsFrame.numTabs+1;

	local framename = "FriendsFrameTab"..n;

	frame = CreateFrame("Button", framename, FriendsFrame);

	frame:SetWidth(115);

	frame:SetHeight(32);

	frame:SetID(n);

	frame:SetPoint("LEFT", getglobal("FriendsFrameTab"..n-1), "RIGHT", -14, 0);

	frame:SetFrameLevel(FriendsFrame:GetFrameLevel() + 4);

	frame:SetScript("ONCLICK", function(self)

		PanelTemplates_Tab_OnClick(self, FriendsFrame);

		FriendsFrame_OnShow();

		GuildControlPopupFrame:Hide();

		GuildMemberDetailFrame:Hide();

		GuildInfoFrame:Hide();

		GuildFrame:Hide();

	end );

	frame:SetScript("ONSHOW", function()

		PanelTemplates_TabResize(this, 0);

		getglobal(this:GetName().."HighlightTexture"):SetWidth(this:GetTextWidth() + 30);

	end );

	-- textures

	local texture;

	texture = frame:CreateTexture(framename.."LeftDisabled", "BACKGROUND");

	texture:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-ActiveTab");

	texture:SetWidth(20);

	texture:SetHeight(32);

	texture:SetPoint("TOPLEFT", frame, "TOPLEFT", 0, 5);

	texture:SetTexCoord( 0, 0.15625, 0, 1.0 );

	texture = frame:CreateTexture(framename.."MiddleDisabled", "BACKGROUND");

	texture:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-ActiveTab");

	texture:SetWidth(88);

	texture:SetHeight(32);

	texture:SetPoint("LEFT", framename.."LeftDisabled", "RIGHT");

	texture:SetTexCoord( 0.15625, 0.84375, 0, 1.0 );

	texture = frame:CreateTexture(framename.."RightDisabled", "BACKGROUND");

	texture:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-ActiveTab");

	texture:SetWidth(20);

	texture:SetHeight(32);

	texture:SetPoint("LEFT", framename.."MiddleDisabled", "RIGHT");

	texture:SetTexCoord( 0.84375, 1.0, 0, 1.0 );

	texture = frame:CreateTexture(framename.."Left", "BACKGROUND");

	texture:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-InActiveTab");

	texture:SetWidth(20);

	texture:SetHeight(32);

	texture:SetPoint("TOPLEFT", frame, "TOPLEFT");

	texture:SetTexCoord( 0, 0.15625, 0, 1.0 );

	texture = frame:CreateTexture(framename.."Middle", "BACKGROUND");

	texture:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-InActiveTab");

	texture:SetWidth(88);

	texture:SetHeight(32);

	texture:SetPoint("LEFT", framename.."Left", "RIGHT");

	texture:SetTexCoord( 0.15625, 0.84375, 0, 1.0 );

	texture = frame:CreateTexture(framename.."Right", "BACKGROUND");

	texture:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-InActiveTab");

	texture:SetWidth(20);

	texture:SetHeight(32);

	texture:SetPoint("LEFT", framename.."Middle", "RIGHT");

	texture:SetTexCoord( 0.84375, 1.0, 0, 1.0 );

	texture = frame:CreateTexture(framename.."HighlightTexture");

	texture:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-Tab-Highlight");

	texture:SetPoint("LEFT", framename, "LEFT", 10, 2);

	texture:SetPoint("RIGHT", framename, "RIGHT", -10, 2);

	texture:SetBlendMode("ADD");

	frame:SetHighlightTexture(texture);

	-- texts

	local font;

	font = frame:CreateFontString(framename.."Text");

	font:SetFontObject(GameFontNormalSmall);

	font:SetPoint("CENTER", frame, "CENTER", 0, 2);

	frame:SetNormalFontObject(font:GetFontObject());

	font:SetText(subtext);

	font = frame:CreateFontString(framename.."HighlightText");

	font:SetFontObject(GameFontHighlightSmall);

	font:SetPoint("CENTER", frame, "CENTER", 0, 2);

	frame:SetHighlightFontObject(font:GetFontObject());

	font = frame:CreateFontString(framename.."DisabledText");

	font:SetFontObject(GameFontDisabledSmall);

	font:SetPoint("CENTER", frame, "CENTER", 0, 2);

	FriendsFrameTab_OnLoad(); -- add to panel of tabs
	
	ToonsFrame_MakeLinkButtons();
	
	ToonsFrameDeleteButton:SetScript("OnEnter", function(button)
				GameTooltip:ClearLines()
				GameTooltip:SetOwner(ToonsFrame, "ANCHOR_BOTTOMRIGHT")

				GameTooltip:AddLine("Delete the selected Toon")
				GameTooltip:AddLine("Only works from Stats page")
			
				GameTooltip:Show()
				end);

	ToonsFrameDeleteButton:SetScript("OnLeave", function(button)
				GameTooltip:Hide()
				end);
	
	return frame, framename;

end



function FriendsFrameToonsTab_Initialize( frame )

	frame:SetScript("ONEVENT", FriendsFrame_Update);

	frame:SetScript("ONENTER", function()

		GameTooltip_AddNewbieTip(frame, TOONS, 1.0, 1.0, 1.0, NEWBIE_TOOLTIP_TOONSTAB, 1);

	end );

	frame:SetScript("ONLEAVE", function()

		GameTooltip:Hide();

	end );

end



local oldFriendsFrame_Update = FriendsFrame_Update;

function FriendsFrame_Update()

	local frame=getglobal(ToonsTabFrame);

	if ( FriendsFrame.selectedTab == frame:GetID() ) then

		FriendsFrameTopLeft:SetTexture("Interface\\ClassTrainerFrame\\UI-ClassTrainer-TopLeft");

		FriendsFrameTopRight:SetTexture("Interface\\ClassTrainerFrame\\UI-ClassTrainer-TopRight");

		FriendsFrameBottomLeft:SetTexture("Interface\\FriendsFrame\\WhoFrame-BotLeft");

		FriendsFrameBottomRight:SetTexture("Interface\\FriendsFrame\\WhoFrame-BotRight");

		FriendsFrameTitleText:SetText(T_TOONS);

		FriendsFrame_ShowSubFrame("ToonsFrame");

		ToonsFrame_Update();

	else

		oldFriendsFrame_Update();

	end

end



function FriendsFrameToonsPlayerButton_OnClick(button)

	if ( button == "LeftButton" ) then

		ToonsFrame.selectedToon = this:GetID();

		ToonsFrame_Update();

	end

end


-- only seems to work correctly on the stats frame page---------  now disabled on others
function ToonsFrameDeleteButton_OnClick(button)

	if ( ToonsFrame.selectedToon ) then

		local player = getglobal("ToonsFramePlayerButton"..ToonsFrame.selectedToon).player;

		local server = ToonsFrame.server;

        local i = 0;

		for k,v in pairs(TOONSTAB[server]) do

			i = i + 1;

		end

		if ( (player~=UnitName("player") or server~=GetRealmName() )and TOONSTAB[server][player] ) then

			TOONSTAB[server][player]=nil;

			if (i <= 1) then

				TOONSTAB[server]=nil;

				ToonsFrame.server=nil;

				ToonsServer = ToonsServer_Sort();

				UIDropDownMenu_SetSelectedID(ToonsFrameServerDropDown, 1);
				
				--ToggleDropDownMenu(level, value, dropDownFrame, anchorName, xOffset, yOffset, menuList, button)
			
				ToggleDropDownMenu(1,1,ToonsFrameServerDropDown);
				
				ToonsFrame_Update(nil, nil);

			end

		ToonsFrame.selectedToon = nil;

		end

	else ToonsFrameIndividualFrame:Hide();
	
	end

	ToonsFrame_Update();

end



function ToonsFrameServerDropDown_OnLoad()

	UIDropDownMenu_Initialize(this, ToonsFrameServerDropDown_Initialize);

	UIDropDownMenu_SetWidth(this, 130);

end



function ToonsFrameServerDropDown_Initialize()

	local info;

	for i=1, #(ToonsServer) do

		info = {};

		info.text = ToonsServer[i];

		if ( info.text==ToonsFrame.server ) then

			info.checked = 1;

		end  

		info.owner = ToonsFrameServerDropDown;

		info.func = ToonsFrameServerButton_OnClick;

		UIDropDownMenu_AddButton(info);

	end

end



function ToonsFrameServerButton_OnClick()

	UIDropDownMenu_SetSelectedID(ToonsFrameServerDropDown, this:GetID());
	
	ToonsFrame.selectedToon = nil;

	ToonsFrame_Update(this:GetText(), nil);
	

end



function ToonsFramePageDropDown_OnLoad()

	UIDropDownMenu_Initialize(this, ToonsFramePageDropDown_Initialize);

	UIDropDownMenu_SetWidth(this, 80);

end



function ToonsFramePageDropDown_Initialize()

	local info;

	for i=1, #(ToonsPage) do

		info = {};

		info.text = TOONSPAGES[ToonsPage[i]].name;

		if ( info.text==ToonsFrame.page ) then

			info.checked = 1;

        end  

		info.owner = ToonsFramePageDropDown;

		info.func = ToonsFramePageButton_OnClick;

		UIDropDownMenu_AddButton(info);

	end

end



function ToonsFramePageButton_OnClick(arg1, arg2)

	UIDropDownMenu_SetSelectedID(ToonsFramePageDropDown, this:GetID());

	ToonsFrame_Update(nil, ToonsPage[this:GetID()]);

end



function ToonsFrame_FormatTimePlayed( played )

	return format(TIMEPLAYEDFORMAT, ChatFrame_TimeBreakDown(played or 0) )

end



function ToonsFrame_Update( server, page )

	if ( not server ) then

		
		if (ToonsFrame.server) then
			server = ToonsFrame.server;
		else 
			server = GetRealmName();
			ToonsFrame.server = server;
		end	
		

	elseif ( TOONSTAB[server] ) then

		ToonsFrame.server = server;

	else

		server = GetRealmName();

		ToonsFrame.server = server;

	end

	if ( not page ) then

		if (ToonsFrame.page) then
			page = ToonsFrame.page;
		else 
			page = "STATSFRAME";
			ToonsFrame.page = page;
		end
	elseif ( TOONSPAGES[page] ) then

		ToonsFrame.page = page;

	else

		page = "STATSFRAME";

		ToonsFrame.page = page;

	end

	local totalgold = 0;

	local totalplayed = 0;

	local sorted;
	
	if not ToonsFrame.sortKey then
		
		ToonsFrame.sortKey = "name"
	
	end
	
	sorted = ToonsFrame_Sort( ToonsFrame.sortKey, server );
    
	local index = #(sorted);

	for i=1, index do

		local stats=sorted[i];

		totalgold = totalgold + (stats.assets.gold or 0);

		totalplayed = totalplayed + (stats.time.timeplayed or 0);

	end

	MoneyFrame_Update("ToonsFrameMoneyFrame", totalgold);

	ToonsFrameTotalPlayedText:SetText( ToonsFrame_FormatTimePlayed(totalplayed) );
	
	ToonsFrameIndividualFrame:Hide();

	ToonsFramePlayedFrame:Hide();

	ToonsFrameXPFrame:Hide();

	ToonsFrameStatsFrame:Hide();

	ToonsFrameGuildFrame:Hide();

	ToonsFrameAssetsFrame:Hide();

	ToonsFrameTradeskillFrame:Hide();

    ToonsFrameSecondaryFrame:Hide();

	ToonsFrameMarksFrame:Hide();
	
	ToonsFrameHonorFrame:Hide();
	
	ToonsFrameDailyFrame:Hide();
	
	ToonsFrameAchieveFrame:Hide();
	
-- top frame pages---------------------------------
	if ( page=="STATSFRAME" ) then

--stats frame ------------------------------------------
		ToonsFrameStatsFrame:Show();
		
		ToonsFrameDeleteButton:Enable();

		for i=1, index do

			if ( i > MAX_TOONS ) then

				break;

			end

			local stats=sorted[i];

			local color;

			getglobal("ToonsFramePlayerButton"..i).player=stats.name;

			getglobal("ToonsFramePlayerButton"..i.."Name"):SetText(stats.name);

			getglobal("ToonsFramePlayerButton"..i.."Level"):SetText(stats.char.level);

			color = {r=1-(stats.char.level)/MAX_LEVEL, g=(stats.char.level)/MAX_LEVEL, b=0 };

			getglobal("ToonsFramePlayerButton"..i.."Level"):SetTextColor(color.r, color.g, color.b);

			getglobal("ToonsFramePlayerButton"..i.."Race"):SetText(stats.char.race);

			color = TOONS_RACES[stats.char.raceEn].color;

			getglobal("ToonsFramePlayerButton"..i.."Race"):SetTextColor(color.r, color.g, color.b);

			getglobal("ToonsFramePlayerButton"..i.."Class"):SetText(stats.char.class);

			color = RAID_CLASS_COLORS[stats.char.classEn];

			getglobal("ToonsFramePlayerButton"..i.."Class"):SetTextColor(color.r, color.g, color.b);

			getglobal("ToonsFramePlayerButton"..i.."Zone"):SetText(stats.char.zone);

			-- Highlight the correct player

			local button = getglobal("ToonsFramePlayerButton"..i);

			button:Show();

			if ( ToonsFrame.selectedToon == i ) then

				button:LockHighlight();

			else

				button:UnlockHighlight();

			end

		end		

		for i=index+1, MAX_TOONS do

			local button = getglobal("ToonsFramePlayerButton"..i);

			getglobal("ToonsFramePlayerButton"..i.."Name"):SetText("");

			getglobal("ToonsFramePlayerButton"..i.."Level"):SetText("");

			getglobal("ToonsFramePlayerButton"..i.."Race"):SetText("");

			getglobal("ToonsFramePlayerButton"..i.."Class"):SetText("");

			getglobal("ToonsFramePlayerButton"..i.."Zone"):SetText("");

			button:UnlockHighlight();

			button:Hide();

		end

	elseif ( page=="XPFRAME" ) then

--experience frame  ---------------------------------

		ToonsFrameXPFrame:Show();
		
		ToonsFrameDeleteButton:Disable();

		for i=1, index do

			if ( i > MAX_TOONS ) then

				break;

			end

			local stats=sorted[i];

			getglobal("ToonsFrameXPButton"..i).player=stats.name;

			getglobal("ToonsFrameXPButton"..i.."Name"):SetText(stats.name);
			
			if ( not stats.txp.rested) then
				stats.txp.rested = 0;
			end

			if stats.txp.xpmax > 10000 then			
				getglobal("ToonsFrameXPButton"..i.."XP"):SetText(floor(stats.txp.xp / 1000).."k");
				getglobal("ToonsFrameXPButton"..i.."XPMax"):SetText(floor(stats.txp.xpmax / 1000).."k");
				getglobal("ToonsFrameXPButton"..i.."Rested"):SetText(floor(stats.txp.rested / 1000).."k");
			else
				getglobal("ToonsFrameXPButton"..i.."XP"):SetText(stats.txp.xp);
				getglobal("ToonsFrameXPButton"..i.."XPMax"):SetText(stats.txp.xpmax);
				getglobal("ToonsFrameXPButton"..i.."Rested"):SetText(stats.txp.rested);
			end

            if ( stats.txp.xp ) and (stats.txp.xpmax > 0) then

				getglobal("ToonsFrameXPButton"..i.."XPPercent"):SetText(floor((stats.txp.xp / stats.txp.xpmax)*100));

			else

				getglobal("ToonsFrameXPButton"..i.."XPPercent"):SetText("");

			end

            if ( not stats.txp.rested or stats.txp.rested <= 0 ) then

                getglobal("ToonsFrameXPButton"..i.."Rested"):SetText("");

                getglobal("ToonsFrameXPButton"..i.."RestedPercent"):SetText("");         

            elseif (stats.txp.rested > 0) then

                getglobal("ToonsFrameXPButton"..i.."RestedPercent"):SetText(floor(((stats.txp.rested*100) / (stats.txp.xpmax * 1.5))));

            end			

			-- Highlight the correct player

			local button = getglobal("ToonsFrameXPButton"..i);

			button:Show();

			if ( ToonsFrame.selectedToon == i ) then

				button:LockHighlight();

			else

				button:UnlockHighlight();

			end

		end				

		for i=index+1, MAX_TOONS do

			local button = getglobal("ToonsFrameXPButton"..i);

			getglobal("ToonsFrameXPButton"..i.."Name"):SetText("");

			getglobal("ToonsFrameXPButton"..i.."XP"):SetText("");

			getglobal("ToonsFrameXPButton"..i.."XPMax"):SetText("");

			getglobal("ToonsFrameXPButton"..i.."XPPercent"):SetText("");

			getglobal("ToonsFrameXPButton"..i.."Rested"):SetText("");

            getglobal("ToonsFrameXPButton"..i.."RestedPercent"):SetText("");

 			button:UnlockHighlight();

			button:Hide();

		end

	elseif ( page=="PLAYEDFRAME" ) then

--time played frame ----------------------------------

		ToonsFramePlayedFrame:Show();
		
		ToonsFrameDeleteButton:Disable();

		for i=1, index do

			if ( i > MAX_TOONS ) then

				break;

			end

			local stats=sorted[i];

			getglobal("ToonsFramePlayedButton"..i).player=stats.name;

			getglobal("ToonsFramePlayedButton"..i.."Name"):SetText(stats.name);

			getglobal("ToonsFramePlayedButton"..i.."TimePlayed"):SetText( ToonsFrame_FormatTimePlayed( stats.time.timeplayed) );

			getglobal("ToonsFramePlayedButton"..i.."TimeAtLevel"):SetText( ToonsFrame_FormatTimePlayed( stats.time.timeatlevel) );

			-- Highlight the correct player

			local button = getglobal("ToonsFramePlayedButton"..i);

			button:Show();

			if ( ToonsFrame.selectedToon == i ) then

				button:LockHighlight();

			else

				button:UnlockHighlight();

			end

		end				

		for i=index+1, MAX_TOONS do

			local button = getglobal("ToonsFramePlayedButton"..i);

			getglobal("ToonsFramePlayedButton"..i.."Name"):SetText("");

			getglobal("ToonsFramePlayedButton"..i.."TimePlayed"):SetText("");

			getglobal("ToonsFramePlayedButton"..i.."TimeAtLevel"):SetText("");

			button:UnlockHighlight();

			button:Hide();

		end

	elseif ( page=="GUILDFRAME" ) then

--guild frame  ----------------------------
		ToonsFrameGuildFrame:Show();
		
		ToonsFrameDeleteButton:Disable();

		for i=1, index do

			if ( i > MAX_TOONS ) then

				break;

			end

			local stats=sorted[i];

			getglobal("ToonsFrameGuildButton"..i).player=stats.name;

			getglobal("ToonsFrameGuildButton"..i.."Name"):SetText(stats.name);

			getglobal("ToonsFrameGuildButton"..i.."GuildName"):SetText(stats.guild.guild);

			getglobal("ToonsFrameGuildButton"..i.."GuildRank"):SetText(stats.guild.guildrank);
			
			getglobal("ToonsFrameGuildButton"..i.."GuildMem"):SetText(stats.guild.gmembers);
			if stats.guild.gmembers == 0 then
				getglobal("ToonsFrameGuildButton"..i.."GuildMem"):SetText("");  --  getting rid of 0's
			end
			-- Highlight the correct player

			local button = getglobal("ToonsFrameGuildButton"..i);

			button:Show();

			if ( ToonsFrame.selectedToon == i ) then

				button:LockHighlight();

			else

				button:UnlockHighlight();

			end

		end				

		for i=index+1, MAX_TOONS do

			local button = getglobal("ToonsFrameGuildButton"..i);

			getglobal("ToonsFrameGuildButton"..i.."Name"):SetText("");

			getglobal("ToonsFrameGuildButton"..i.."GuildName"):SetText("");

			getglobal("ToonsFrameGuildButton"..i.."GuildRank"):SetText("");
			
			getglobal("ToonsFrameGuildButton"..i.."GuildMem"):SetText("");

			button:UnlockHighlight();

			button:Hide();

		end

	elseif ( page=="ASSETSFRAME" ) then

--Money frame ---------------------------------------------
		ToonsFrameAssetsFrame:Show();
		
		ToonsFrameDeleteButton:Disable();

		for i=1, index do

			if ( i > MAX_TOONS ) then

				break;

			end

			local stats=sorted[i];

			getglobal("ToonsFrameAssetsButton"..i).player=stats.name;

			getglobal("ToonsFrameAssetsButton"..i.."Name"):SetText(stats.name);

			MoneyFrame_Update("ToonsFrameAssetsButton"..i.."Gold", stats.assets.gold);

			getglobal("ToonsFrameAssetsButton"..i.."Bags"):SetText((stats.assets.bagssize or 0).."/"..(stats.assets.bagsmax or 0));

			getglobal("ToonsFrameAssetsButton"..i.."Bank"):SetText((stats.assets.banksize or 0).."/"..(stats.assets.bankmax or 0));

			-- Highlight the correct player

			local button = getglobal("ToonsFrameAssetsButton"..i);

			button:Show();

			if ( ToonsFrame.selectedToon == i ) then

				button:LockHighlight();

			else

				button:UnlockHighlight();

			end

		end				

		for i=index+1, MAX_TOONS do

			local button = getglobal("ToonsFrameAssetsButton"..i);

			getglobal("ToonsFrameAssetsButton"..i.."Name"):SetText("");

			MoneyFrame_Update("ToonsFrameAssetsButton"..i.."Gold", 0);

			button:UnlockHighlight();

			button:Hide();

		end

	elseif ( page=="TRADESKILLFRAME" ) then

--tradeskill frame -------------------------
		ToonsFrameTradeskillFrame:Show();
		
		ToonsFrameDeleteButton:Disable();

		for i=1, index do

			if ( i > MAX_TOONS ) then

				break;

			end

			local stats=sorted[i];

			-- using function now to populate data for buttons --------------
			ToonsTradeFrame(stats, i, "ToonsFrameTradeskillButton", "Tradeskill1", server )
			ToonsTradeFrame(stats, i, "ToonsFrameTradeskillButton", "Tradeskill2", server )

			-- Highlight the correct player

			local button = getglobal("ToonsFrameTradeskillButton"..i);

			button:Show();

			if ( ToonsFrame.selectedToon == i ) then

				button:LockHighlight();

			else

				button:UnlockHighlight();

			end

		end				

		for i=index+1, MAX_TOONS do

			local button = getglobal("ToonsFrameTradeskillButton"..i);

			getglobal("ToonsFrameTradeskillButton"..i.."Name"):SetText("");

			button:UnlockHighlight();

			button:Hide();
			
			local Button = getglobal("ToonsFrameTradeskillButtonLink"..i.."Tradeskill1");
			Button:Disable();
			Button:SetScript("OnClick", nil);
			Button:Hide();
			local Button = getglobal("ToonsFrameTradeskillButtonLink"..i.."Tradeskill2");
			Button:Disable();
			Button:SetScript("OnClick", nil);
			Button:Hide();

		end

	elseif ( page=="SECONDARYFRAME" ) then

--Secondary skill frame ---------------------------

		ToonsFrameSecondaryFrame:Show();
		
		ToonsFrameDeleteButton:Disable();

		for i=1, index do

			if ( i > MAX_TOONS ) then

				break;

			end

			local stats=sorted[i];

			-- using function now to populate data for buttons --------------
			ToonsSecondaryFrame(stats, i, "ToonsFrameSecondaryButton", "Tradeskill3", server );
			ToonsSecondaryFrame(stats, i, "ToonsFrameSecondaryButton", "Tradeskill4", server );
			ToonsSecondaryFrame(stats, i, "ToonsFrameSecondaryButton", "Tradeskill5", server );

			-- Highlight the correct player

			local button = getglobal("ToonsFrameSecondaryButton"..i);

			button:Show();

			if ( ToonsFrame.selectedToon == i ) then

				button:LockHighlight();

			else

				button:UnlockHighlight();

			end

		end				

		for i=index+1, MAX_TOONS do

			local button = getglobal("ToonsFrameSecondaryButton"..i);

			getglobal("ToonsFrameSecondaryButton"..i.."Name"):SetText("");

			button:UnlockHighlight();

			button:Hide();
			
			local Button = getglobal("ToonsFrameSecondaryButtonLink"..i.."Tradeskill3");
			Button:Disable();
			Button:SetScript("OnClick", nil);
			Button:Hide();
			local Button = getglobal("ToonsFrameSecondaryButtonLink"..i.."Tradeskill4");
			Button:Disable();
			Button:SetScript("OnClick", nil);
			Button:Hide();
			
		end

	elseif ( page=="MARKSFRAME" ) then

--Marks Frame.................replaced rogue frame   --------------------------    needs gone
		ToonsFrameMarksFrame:Show();
		
		ToonsFrameDeleteButton:Disable();

		for i=1, index do

			if ( i > MAX_TOONS ) then

				break;

			end

			local stats=sorted[i];

			local color, text;

			getglobal("ToonsFrameMarksButton"..i).player=stats.name;

			getglobal("ToonsFrameMarksButton"..i.."Name"):SetText(stats.name);

			getglobal("ToonsFrameMarksButton"..i.."AVMarks"):SetText(stats.marks.avmarks or "");
			color = {r=((100 - stats.marks.avmarks) / 100), g=(stats.marks.avmarks), b=(.3) };
			getglobal("ToonsFrameMarksButton"..i.."AVMarks"):SetTextColor(color.r, color.g, color.b);

			getglobal("ToonsFrameMarksButton"..i.."WSMarks"):SetText(stats.marks.wsmarks or "");
			color = {r=((100 - stats.marks.wsmarks) / 100), g=(stats.marks.wsmarks), b=(.3) };
			getglobal("ToonsFrameMarksButton"..i.."WSMarks"):SetTextColor(color.r, color.g, color.b);

			getglobal("ToonsFrameMarksButton"..i.."ABMarks"):SetText(stats.marks.abmarks or "");
			color = {r=((100 - stats.marks.abmarks) / 100), g=(stats.marks.abmarks), b=(.3) };
			getglobal("ToonsFrameMarksButton"..i.."ABMarks"):SetTextColor(color.r, color.g, color.b);

			getglobal("ToonsFrameMarksButton"..i.."ESMarks"):SetText(stats.marks.esmarks or "");
			color = {r=((100 - stats.marks.esmarks) / 100), g=(stats.marks.esmarks), b=(.3) };
			getglobal("ToonsFrameMarksButton"..i.."ESMarks"):SetTextColor(color.r, color.g, color.b);

			getglobal("ToonsFrameMarksButton"..i.."SAMarks"):SetText(stats.marks.samarks or "");
			color = {r=((100 - stats.marks.samarks) / 100), g=(stats.marks.samarks), b=(.3) };
			getglobal("ToonsFrameMarksButton"..i.."SAMarks"):SetTextColor(color.r, color.g, color.b);

			getglobal("ToonsFrameMarksButton"..i.."WGMarks"):SetText(stats.marks.wgmarks or "");
			color = {r=((100 - stats.marks.wgmarks) / 100), g=(stats.marks.wgmarks), b=(.3) };
			getglobal("ToonsFrameMarksButton"..i.."WGMarks"):SetTextColor(color.r, color.g, color.b);



			-- Highlight the correct player

			local button = getglobal("ToonsFrameMarksButton"..i);

			button:Show();

			if ( ToonsFrame.selectedToon == i ) then

				button:LockHighlight();

			else

				button:UnlockHighlight();

			end

		end				

		for i=index+1, MAX_TOONS do

			local button = getglobal("ToonsFrameMarksButton"..i);

			getglobal("ToonsFrameMarksButton"..i.."Name"):SetText("");

			button:UnlockHighlight();

			button:Hide();

		end
	
	elseif ( page=="HONORFRAME" ) then

--honor frame  -------------------------------------

		ToonsFrameHonorFrame:Show();
		
		ToonsFrameDeleteButton:Disable();

		for i=1, index do

			if ( i > MAX_TOONS ) then

				break;

			end

			local stats=sorted[i];

			local color, text;

			getglobal("ToonsFrameHonorButton"..i).player=stats.name;

			getglobal("ToonsFrameHonorButton"..i.."Name"):SetText(stats.name);

			getglobal("ToonsFrameHonorButton"..i.."ArenaPoints"):SetText(stats.honor.arenapoints or 0);

			getglobal("ToonsFrameHonorButton"..i.."HonorPoints"):SetText(stats.honor.honorpoints or 0);

			getglobal("ToonsFrameHonorButton"..i.."LifeKill"):SetText(stats.honor.lifekill or 0);


			-- Highlight the correct player

			local button = getglobal("ToonsFrameHonorButton"..i);

			button:Show();

			if ( ToonsFrame.selectedToon == i ) then

				button:LockHighlight();

			else

				button:UnlockHighlight();

			end

		end				

		for i=index+1, MAX_TOONS do

			local button = getglobal("ToonsFrameHonorButton"..i);

			getglobal("ToonsFrameHonorButton"..i.."Name"):SetText("");

			button:UnlockHighlight();

			button:Hide();

		end

	elseif ( page=="DAILYFRAME" ) then

--Daily frame  --------------------------------
            
		ToonsFrameDailyFrame:Show();
		
		ToonsFrameDeleteButton:Disable();

		for i=1, index do

			if ( i > MAX_TOONS ) then

				break;

			end

			local stats=sorted[i];
			
			local color, text, offline;
            --local hour, min, sec, wday, day, month, year, yday, isdst = date("*t");
			local ctime = date("*t");
            
			getglobal("ToonsFrameDailyButton"..i).player=stats.name;

			getglobal("ToonsFrameDailyButton"..i.."Name"):SetText(stats.name);
			local dhour, dmin, dmonth, dyear, dyday, offset;
			local Shour, Sminutes = GetGameTime();
			dmin = ctime.min - stats.lpdate.min;
			dhour = ctime.hour - stats.lpdate.hour;
			dyday = ctime.yday - stats.lpdate.yday;
			dmonth = ctime.month - stats.lpdate.month;
			dyear = ctime.year - stats.lpdate.year;
			if not (TOONSVAR.offset[server]) then
				offset = ctime.hour - Shour;
			else offset = TOONSVAR.offset[server];

			end

			if dyear > 1 then
				text = dyear.." years ago";
				color = { r=1, g=0, b=0};
			elseif dyear == 1 then
				dmonth = dmonth + 12;
				text = dmonth.." months ago";
				color = { r=1, g=0, b=0};
			elseif dyday > 1 then
				text = dyday.." days ago";
				color = { r=1, g=0, b=0};
			elseif dyday == 1 then
				dhour = dhour + 24;
				text = dhour.." hours ago";
				color = { r=1, g=.6, b=0};
			elseif dhour > 1 then
				text = dhour.." hours ago";
				color = { r=1, g=1, b=0};
			elseif dhour == 1 then
				dmin = dmin + 60;
				text = dmin.." min ago";
				color = { r=0, g=1, b=0};
			elseif dmin >= 30 then
				text = dmin.." min ago";
				color = { r=0, g=1, b=0};
			elseif dmin < 30 then
				text = dmin.." min ago";
				color = { r=1, g=1, b=1};
			else text = " Unknown";
				color = { r=1, g=1, b=0};
			end
			if dhour >= 23  or dyday > 1 then
				color = { r=1, g=0, b=0};
			elseif dyday <= 1 and ctime.hour >= (3 + offset) and stats.lpdate.hour < (3 + offset) then				
				color = { r=1, g=.6, b=0};
			end
	
			getglobal("ToonsFrameDailyButton"..i.."Last"):SetText(text);
			
			getglobal("ToonsFrameDailyButton"..i.."Last"):SetTextColor(color.r, color.g, color.b);


		-- daily comes after last time to override color if needed
			text = stats.dailies.daily.."/"..stats.dailies.dailymax;
			
			getglobal("ToonsFrameDailyButton"..i.."Daily"):SetText(text);
			
			if stats.dailies.dailymax - stats.dailies.daily < 1 then
				
				color = { r=1, g=0, b=0};
			
			elseif  stats.dailies.dailymax - stats.dailies.daily < 10 then
				
				color = { r=1, g=1, b=0};
				
			elseif  stats.dailies.dailymax - stats.dailies.daily < 15 then
				
				color = { r=0, g=1, b=1};
			
			elseif  stats.dailies.dailymax - stats.dailies.daily < 20 then
				
				color = { r=0, g=1, b=0};
				
			else color = { r=1, g=1, b=1};
			
			end
			
			if dhour >= 24  or dyday > 1 then
				
				color = { r=1, g=0, b=0};
			
			elseif dhour <= 24 and ctime.hour >= (3 + offset) and stats.lpdate.hour < (3 + offset) then
				
				color = { r=1, g=.6, b=0};
				
			end
			
			getglobal("ToonsFrameDailyButton"..i.."Daily"):SetTextColor(color.r, color.g, color.b);


			-- Highlight the correct player

			local button = getglobal("ToonsFrameDailyButton"..i);

			button:Show();

			if ( ToonsFrame.selectedToon == i ) then

				button:LockHighlight();

			else

				button:UnlockHighlight();

			end

		end				

		for i=index+1, MAX_TOONS do

			local button = getglobal("ToonsFrameDailyButton"..i);

			getglobal("ToonsFrameDailyButton"..i.."Name"):SetText("");

			button:UnlockHighlight();

			button:Hide();

		end
		
		
	elseif ( page=="ACHIEVEFRAME" ) then

--Achievement frame  -------------------------------------

		ToonsFrameAchieveFrame:Show();
		
		ToonsFrameDeleteButton:Disable();

		for i=1, index do

			if ( i > MAX_TOONS ) then

				break;

			end

			local stats=sorted[i];

			local color, text;

			getglobal("ToonsFrameAchieveButton"..i).player=stats.name;

			getglobal("ToonsFrameAchieveButton"..i.."Name"):SetText(stats.name);

			getglobal("ToonsFrameAchieveButton"..i.."Acomplete"):SetText(stats.achieve.acompleted or 0);

			getglobal("ToonsFrameAchieveButton"..i.."Atotal"):SetText(stats.achieve.atotal or 0);

			getglobal("ToonsFrameAchieveButton"..i.."Apoints"):SetText(stats.achieve.apoints or 0);


			-- Highlight the correct player

			local button = getglobal("ToonsFrameAchieveButton"..i);

			button:Show();

			if ( ToonsFrame.selectedToon == i ) then

				button:LockHighlight();

			else

				button:UnlockHighlight();

			end

		end				

		for i=index+1, MAX_TOONS do

			local button = getglobal("ToonsFrameAchieveButton"..i);

			getglobal("ToonsFrameAchieveButton"..i.."Name"):SetText("");

			button:UnlockHighlight();

			button:Hide();

		end	
-- end of pages ----------------
	end

--show individual info for selected toon -------------------------------     ind frame
		
	local stats=sorted[ToonsFrame.selectedToon];


	if ( stats ) then

        ToonsFrameIndividualGoldFrame:Hide();

		ToonsFrameIndividualFrame:Show();

		ToonsFrameIndividualGoldFrame:Hide();

		local text, font, color = "";

-- stats ind frame -------------------------------------

		font = ToonsFrameIndividualStatsText;

		text = NORMAL_FONT_COLOR_CODE..stats.name.."|r ";

		color = {r=(stats.char.level)/MAX_LEVEL, g=1-(stats.char.level)/MAX_LEVEL, b=0 };

		color = format("|cff%2x%2x%2x", color.r * 255, color.g *255, color.b * 255);

		text = text..", Level "..color..stats.char.level.."|r ";

		text = text..TOONS_RACES[stats.char.raceEn].fontcolor..stats.char.race.."|r ";

        color = RAID_CLASS_COLORS[stats.char.classEn];

        color = format("|cff%2x%2x%2x", color.r * 255, color.g *255, color.b * 255);

		text = text..color..stats.char.class.."|r ";

		text = text.." in "..stats.char.zone.." ";

		font:SetText(text);

-- experience ind frame -----------------------------

		font = ToonsFrameIndividualXPText;

		text = NORMAL_FONT_COLOR_CODE..EXPERIENCE_COLON.."|r";

		if ( stats.txp.xp ) then

			text = text..stats.txp.xp.."/"..stats.txp.xpmax.." @ "..(floor((stats.txp.xp / stats.txp.xpmax)*100)).."%";

	        if ( stats.txp.rested ) and ( stats.txp.rested ~= 0 )then

--          	  text = text..NORMAL_FONT_COLOR_CODE.."  Rested:|r"..stats.rested.." @ "..(floor(((stats.rested * 100) / (stats.xpmax * 1.5)))).."% ";    -- removed rested number for fitting in frame
		text = text..NORMAL_FONT_COLOR_CODE.."  Rested:|r".." @ "..(floor(((stats.txp.rested * 100) / (stats.txp.xpmax * 1.5)))).."% ";

			end

        end

		font:SetText(text);

-- time played ind frame ----------------------------------

		font = ToonsFrameIndividualPlayedText;

		text = NORMAL_FONT_COLOR_CODE..T_TIMEPLAYED..":|r ";

		text = text..(ToonsFrame_FormatTimePlayed( stats.time.timeplayed)).." ";

		text = text..NORMAL_FONT_COLOR_CODE..T_THISLEVEL..":|r ";

		text = text..(ToonsFrame_FormatTimePlayed( stats.time.timeatlevel)).." ";

  		font:SetText(text);

-- guild ind frame -------------------------

        font = ToonsFrameIndividualGuildText;

		if ( stats.guild.guild ) and (stats.guild.guild ~= "") then

			text = NORMAL_FONT_COLOR_CODE..T_GUILD..":|r ";

			text = text..stats.guild.guild.."   ";

			text = text..NORMAL_FONT_COLOR_CODE..T_RANK..":|r ";

			text = text..stats.guild.guildrank.." ";

		else

			text = NORMAL_FONT_COLOR_CODE..oldGuildErrorMsg..":|r \n";

		end

		font:SetText(text);



-- assets ind frame --------------------

		MoneyFrame_Update("ToonsFrameIndividualGoldFrame", stats.assets.gold);

		ToonsFrameIndividualGoldFrame:Show();

		font = ToonsFrameIndividualAssetsText;

		text = NORMAL_FONT_COLOR_CODE..T_BAGS.."|r ";

		text = text..(stats.assets.bagssize or 0).."/"..(stats.assets.bagsmax or 0).." ";

		text = text..NORMAL_FONT_COLOR_CODE..T_BANK.."|r ";

		text = text..(stats.assets.banksize or 0).."/"..(stats.assets.bankmax or 0).." ";

		font:SetText(text);

-- tradeskills ind frame  ---------------------

		font = ToonsFrameIndividualTradeskillText;

		if  ( not stats.profs.tradeskill1 ) then

			text = T_NO_PROFESSIONS;

		elseif (stats.profs.tradeskill1 == "") then

            text = T_NO_PROFESSIONS;

		else

			local color ;

			text = NORMAL_FONT_COLOR_CODE..T_TRADE_SKILL.." 1:|r ";

        	color = SKILL_TYPE[stats.profs.tradeskill1].fontcolor;

			text = text..color..stats.profs.tradeskill1.."|r  ";

			color=format("|cff%2x%2x%2x", stats.profs.tradeskill1rank/MAX_SKILL*255 or 1, (.5+stats.profs.tradeskill1rank/(MAX_SKILL*2))*255 or 1, stats.profs.tradeskill1rank/MAX_SKILL*255 or 1);

			text = text..color..stats.profs.tradeskill1rank.."/"..stats.profs.tradeskill1max.." "..SKILL_RANK[stats.profs.tradeskill1max].."|r ";

			if (stats.profs.tradeskill2 == "") then

			elseif (stats.profs.tradeskill2 ) then

				text = text.."\n"..NORMAL_FONT_COLOR_CODE..T_TRADE_SKILL.." 2:|r ";

                color = SKILL_TYPE[stats.profs.tradeskill2].fontcolor;

				text = text..color..stats.profs.tradeskill2.."|r  ";

        		color=format("|cff%2x%2x%2x", stats.profs.tradeskill2rank/MAX_SKILL*255 or 1, (.5+stats.profs.tradeskill2rank/(MAX_SKILL*2))*255 or 1, stats.profs.tradeskill2rank/MAX_SKILL*255 or 1);

				text = text..color..stats.profs.tradeskill2rank.."/"..stats.profs.tradeskill2max.." "..SKILL_RANK[stats.profs.tradeskill2max].."|r ";

			end

		end

  		font:SetText(text);

 -- Hearthstone + rogue ----------------

		font = ToonsFrameIndividualHomeText;

		if ( not stats.char.homeinn ) or (stats.char.homeinn == "") then

			text = NORMAL_FONT_COLOR_CODE..T_HOME.."|r ".." unknown";

  		else

			if (stats.char.homeinn == "your inn") then

    			text = "You are currently homeless";

        	else text = NORMAL_FONT_COLOR_CODE..T_HOME.."|r "..(stats.char.homeinn);

			end

		end
		if stats.char.classEn == "ROGUE" then
			if (stats.profs.tradeskill6) and (stats.profs.tradeskill6 ~= "") then
				color = SKILL_TYPE[stats.profs.tradeskill6 or ""].color;
				color = format("|cff%2x%2x%2x", color.r * 255, color.g *255, color.b * 255);
			
				if ( stats.profs.tradeskill6rank ) and ( stats.profs.tradeskill6rank ~= 0 ) then
					text = text..color.."      "..stats.profs.tradeskill6..":|r   ";							
					color = {r=(1-((stats.profs.tradeskill6rank or 0)/(stats.profs.tradeskill6max))), g=(stats.profs.tradeskill6rank or 0)/(stats.profs.tradeskill6max), b=0};
					color = format("|cff%2x%2x%2x", color.r * 255, color.g *255, color.b * 255);
					text = text..color..stats.profs.tradeskill6rank.."/"..stats.profs.tradeskill6max;			
				end			
			end		
		end
		
		font:SetText(text);

	else

		ToonsFrameIndividualFrame:Hide();		

	end	

end
-- Makes the link buttons 1-10 for tradeskill and secondary frames -------------
function ToonsFrame_MakeLinkButtons()

	for i = 1, MAX_TOONS do
	 local Button = CreateFrame("Button", "ToonsFrameTradeskillButtonLink"..i.."Tradeskill1",ToonsFrameTradeskillFrame,"FriendsFrameToonsTradeskillButtonLinkTemplate");
	 local Button = CreateFrame("Button", "ToonsFrameTradeskillButtonLink"..i.."Tradeskill2",ToonsFrameTradeskillFrame,"FriendsFrameToonsTradeskillButtonLinkTemplate");
	 local Button = CreateFrame("Button", "ToonsFrameSecondaryButtonLink"..i.."Tradeskill3", ToonsFrameSecondaryFrame, "FriendsFrameToonsTradeskillButtonLinkTemplate");
	 local Button = CreateFrame("Button", "ToonsFrameSecondaryButtonLink"..i.."Tradeskill4",ToonsFrameSecondaryFrame,"FriendsFrameToonsTradeskillButtonLinkTemplate");
	 local Button = CreateFrame("Button", "ToonsFrameSecondaryButtonLink"..i.."Tradeskill5",ToonsFrameSecondaryFrame,"FriendsFrameToonsTradeskillButtonLinkTemplate");
	end
end
--       Repeated data population for Secondary frame   ----------------------------
function ToonsTradeFrame(stats, i, frame, Skill, server)
			local color, text;
			local SkillRank = Skill.."Rank";
			local SkillMax = Skill.."Max";
			local skill = strlower(Skill);
			local skillrank = strlower(SkillRank);
			local skillmax = strlower(SkillMax);
			
			local offset = {};
			offset["Tradeskill1"] = 5;
			offset["Tradeskill2"] = 125;

			getglobal(frame..i).player=stats.name;

			getglobal(frame..i.."Name"):SetText(stats.name);

			getglobal(frame..i..Skill):SetText(stats.profs[skill]);

			if ( not stats.profs[skill] ) or ( stats.profs[skill] == "") then 

				color = NORMAL_FONT_COLOR_CODE;

			else color = SKILL_TYPE[stats.profs[skill]].color;

			end

			getglobal(frame..i..Skill):SetTextColor(color.r, color.g, color.b);
-- clickable tslink
			local Button = getglobal(frame.."Link"..i..Skill)
			if stats.tslink and stats.tslink[skill] then
			Button:Enable();
			Button:RegisterForClicks("LeftButtonUp","RightButtonUp");
			Button:SetScript("OnClick", function (self, button, down)
				local link = stats.tslink[skill]
				if button == "LeftButton" then
					if IsShiftKeyDown() then
						if (not ChatEdit_InsertLink(link) ) then
							ChatFrameEditBox:Show()
							ChatEdit_InsertLink(link)
						end
					elseif IsAltKeyDown() then
						print ("link is "..link)
					elseif IsControlKeyDown() then
						local link = string.match(link, "(trade:%d+:%d+:%d+:%w+:[A-Za-z0-9+/]+)")
						ItemRefTooltip:SetHyperlink(link)
					end
				elseif button == "RightButton" then
					if IsShiftKeyDown() then
						local link = string.match(link, "(trade:%d+:%d+:%d+:%w+:[A-Za-z0-9+/]+)")
						ItemRefTooltip:SetHyperlink(link)
					end
				end
				end );
				
			Button:SetScript("OnEnter", function(button)
				GameTooltip:ClearLines()
				GameTooltip:SetOwner(ToonsFrame, "ANCHOR_BOTTOMRIGHT")

				GameTooltip:AddLine(T_SCLICK)
				GameTooltip:AddLine(T_CCLICK)
				GameTooltip:AddLine(T_SRCLICK)
			
				GameTooltip:Show()
				end);

			Button:SetScript("OnLeave", function(button)
				GameTooltip:Hide()
				end);

			Button:Show();	
			Button:SetWidth(50); Button:SetHeight(12); Button:SetPoint("CENTER");
			Button:SetPoint("LEFT", frame..i, "RIGHT", offset[Skill], 0);
			end
			if not (stats.tslink) or not (stats.tslink[skill]) or ( server ~= GetRealmName()) then
				Button:Disable();
				Button:SetScript("OnClick", nil);
				Button:Hide();
			end
			
-- end clickie
			if ( stats.profs[skillrank] )  and ( stats.profs[skillrank] ~= 0) then

				text = stats.profs[skillrank].."/"..stats.profs[skillmax];

			else

				text = "";

			end

			getglobal(frame..i..SkillRank):SetText(text);
			
			if (stats.profs[skillrank]) and (stats.profs[skillrank] > 0) and (stats.profs[skillmax] > 0) then
				color = ((stats.profs[skillmax] - stats.profs[skillrank] +1)/150);
			else color = 0;
			end
			color = {r=(sqrt(color*2)), g=((.7 - color)*2), b= (0)};

			getglobal(frame..i..SkillRank):SetTextColor(color.r, color.g, color.b);
			
			return stats, i, frame, skill;
end
--       Repeated data population for Secondary frame   ----------------------------
function ToonsSecondaryFrame(stats, i, frame, Skill, server)
			local color, text;
			local SkillRank = Skill.."Rank";
			local SkillMax = Skill.."Max";
			local skill = strlower(Skill);
			local skillrank = strlower(SkillRank);
			local skillmax = strlower(SkillMax);
			
			local offset = {};
			offset['Tradeskill3'] = 5;
			offset['Tradeskill4'] = 85;
			offset['Tradeskill5'] = 170;
			
			
			
			getglobal(frame..i).player=stats.name;

			getglobal(frame..i.."Name"):SetText(stats.name);

			if ( stats.profs[skillrank] )   and ( stats.profs[skillrank] ~= 0)then

				text = stats.profs[skillrank].."/"..stats.profs[skillmax];

			else

				text = "";

			end

			getglobal(frame..i..SkillRank):SetText(text);

			if (stats.profs[skillrank] > 0) and (stats.profs[skillmax] > 0) then
				color = ((stats.profs[skillmax] - stats.profs[skillrank] +1)/150);
			else color = 0;
			end
			color = {r=(sqrt(color*2)), g=((.7 - color)*2), b= (0)};
			getglobal(frame..i..SkillRank):SetTextColor(color.r, color.g, color.b);
-- clickable tslink
			local Button = getglobal(frame.."Link"..i..Skill);
			if stats.tslink and stats.tslink[skill] then
			Button:Enable();
			Button:RegisterForClicks("LeftButtonUp","RightButtonUp");
			Button:SetScript("OnClick", function (self, button, down)
				local link = stats.tslink[skill]
				if button == "LeftButton" then
					if IsShiftKeyDown() then
						if (not ChatEdit_InsertLink(link) ) then
							ChatFrameEditBox:Show()
							ChatEdit_InsertLink(link)
						end
					elseif IsAltKeyDown() then
						print ("link is "..link)
					elseif IsControlKeyDown() then
						local link = string.match(link, "(trade:%d+:%d+:%d+:%w+:[A-Za-z0-9+/]+)")
						ItemRefTooltip:SetHyperlink(link)
					end
				elseif button == "RightButton" then
					if IsShiftKeyDown() then
						local link = string.match(link, "(trade:%d+:%d+:%d+:%w+:[A-Za-z0-9+/]+)")
						ItemRefTooltip:SetHyperlink(link)
					end
				end
				end );
								
			Button:SetScript("OnEnter", function(button)
				GameTooltip:ClearLines()
				GameTooltip:SetOwner(ToonsFrame, "ANCHOR_BOTTOMRIGHT")

				GameTooltip:AddLine(T_SCLICK)
				GameTooltip:AddLine(T_CCLICK)
				GameTooltip:AddLine(T_SRCLICK)
			
				GameTooltip:Show()
				end);

			Button:SetScript("OnLeave", function(button)
				GameTooltip:Hide()
				end);
				
			Button:Show();	
			Button:SetWidth(50); Button:SetHeight(12); Button:SetPoint("CENTER");
			
			Button:SetPoint("LEFT", frame..i, "RIGHT", offset[Skill], 0);
			end
			if not (stats.tslink) or ( server ~= GetRealmName()) then
				Button:Disable();
				Button:SetScript("OnClick", nil);
				Button:Hide();
			end
						
-- end clickie

	return stats, i, frame, skill;
	
end